org.eclipse.jetty.servlet

## Class ErrorPageErrorHandler

- java.lang.Object
- - org.eclipse.jetty.util.component.AbstractLifeCycle
  - - org.eclipse.jetty.util.component.AggregateLifeCycle
    - - org.eclipse.jetty.server.handler.AbstractHandler
      - - org.eclipse.jetty.server.handler.ErrorHandler
        - - org.eclipse.jetty.servlet.ErrorPageErrorHandler

All Implemented Interfaces:
  Handler, Destroyable, Dumpable, LifeCycle

    public class ErrorPageErrorHandler
    extends ErrorHandler

Error Page Error Handler An ErrorHandler that maps exceptions and status codes to URIs for dispatch using the internal ERROR style of dispatch.

### Nested Class Summary

### Nested classes/interfaces inherited from class org.eclipse.jetty.util.component.AbstractLifeCycle

`AbstractLifeCycle.AbstractLifeCycleListener`

### Nested classes/interfaces inherited from interface org.eclipse.jetty.util.component.LifeCycle

`LifeCycle.Listener`

### Field Summary

Fields
`protected javax.servlet.ServletContext` `_servletContext`
`static String` `ERROR_PAGE`
`static String` `GLOBAL_ERROR_PAGE`

### Fields inherited from class org.eclipse.jetty.util.component.AbstractLifeCycle

`_listeners, FAILED, RUNNING, STARTED, STARTING, STOPPED, STOPPING`

### Constructor Summary

Constructors
Constructor and Description
`ErrorPageErrorHandler()`

### Method Summary

Methods
`void` `addErrorPage(Class<? extends Throwable> exception, String uri)` Add Error Page mapping for an exception class This method is called as a result of an exception-type element in a web.xml file or may be called directly
`void` `addErrorPage(int from, int to, String uri)` Add Error Page mapping for a status code range.
`void` `addErrorPage(int code, String uri)` Add Error Page mapping for a status code.
`void` `addErrorPage(String exceptionClassName, String uri)` Add Error Page mapping for an exception class This method is called as a result of an exception-type element in a web.xml file or may be called directly
`protected void` `doStart()` Start the managed lifecycle beans in the order they were added.
`protected void` `doStop()` Stop the joined lifecycle beans in the reverse order they were added.
`Map<String,String>` `getErrorPages()`
`void` `handle(String target, Request baseRequest, javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)` Handle a request.
`void` `setErrorPages(Map<String,String> errorPages)`

### Methods inherited from class org.eclipse.jetty.server.handler.ErrorHandler

`getCacheControl, getShowMessageInTitle, handleErrorPage, isShowStacks, setCacheControl, setShowMessageInTitle, setShowStacks, write, writeErrorPage, writeErrorPageBody, writeErrorPageHead, writeErrorPageMessage, writeErrorPageStacks`

### Methods inherited from class org.eclipse.jetty.server.handler.AbstractHandler

`destroy, dumpThis, getServer, setServer`

### Methods inherited from class org.eclipse.jetty.util.component.AggregateLifeCycle

`addBean, addBean, contains, dump, dump, dump, dump, dump, dumpObject, dumpStdErr, getBean, getBeans, getBeans, isManaged, manage, removeBean, removeBeans, unmanage`

### Methods inherited from class org.eclipse.jetty.util.component.AbstractLifeCycle

`addLifeCycleListener, getState, getState, isFailed, isRunning, isStarted, isStarting, isStopped, isStopping, removeLifeCycleListener, start, stop`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.eclipse.jetty.util.component.LifeCycle

`addLifeCycleListener, isFailed, isRunning, isStarted, isStarting, isStopped, isStopping, removeLifeCycleListener, start, stop`

### Field Detail

#### ERROR_PAGE

    public static final String ERROR_PAGE

See Also:
  Constant Field Values

#### GLOBAL_ERROR_PAGE

    public static final String GLOBAL_ERROR_PAGE

See Also:
  Constant Field Values

#### _servletContext

    protected javax.servlet.ServletContext _servletContext

### Constructor Detail

#### ErrorPageErrorHandler

    public ErrorPageErrorHandler()

### Method Detail

#### handle

    public void handle(String target,
              Request baseRequest,
              javax.servlet.http.HttpServletRequest request,
              javax.servlet.http.HttpServletResponse response)
                throws IOException

Description copied from interface: `Handler`
Handle a request.

Specified by:
  `handle` in interface `Handler`
Overrides:
  `handle` in class `ErrorHandler`
Parameters:
  `target` - The target of the request - either a URI or a name.
  `baseRequest` - The original unwrapped request object.
  `request` - The request either as the `Request` object or a wrapper of that request. The `AbstractHttpConnection.getCurrentConnection()` method can be used access the Request object if required.
  `response` - The response as the `Response` object or a wrapper of that request. The `AbstractHttpConnection.getCurrentConnection()` method can be used access the Response object if required.
Throws:
  `IOException`
See Also:
  `ErrorHandler.handle(String, Request, HttpServletRequest, HttpServletResponse)`

#### getErrorPages

    public Map<String,String> getErrorPages()

Returns:
  Returns the errorPages.

#### setErrorPages

    public void setErrorPages(Map<String,String> errorPages)

Parameters:
  `errorPages` - The errorPages to set. A map of Exception class name or error code as a string to URI string

#### addErrorPage

    public void addErrorPage(Class<? extends Throwable> exception,
                    String uri)

Add Error Page mapping for an exception class This method is called as a result of an exception-type element in a web.xml file or may be called directly

Parameters:
  `exception` - The exception
  `uri` - The URI of the error page.

#### addErrorPage

    public void addErrorPage(String exceptionClassName,
                    String uri)

Add Error Page mapping for an exception class This method is called as a result of an exception-type element in a web.xml file or may be called directly

Parameters:
  `exceptionClassName` - The exception
  `uri` - The URI of the error page.

#### addErrorPage

    public void addErrorPage(int code,
                    String uri)

Add Error Page mapping for a status code. This method is called as a result of an error-code element in a web.xml file or may be called directly

Parameters:
  `code` - The HTTP status code to match
  `uri` - The URI of the error page.

#### addErrorPage

    public void addErrorPage(int from,
                    int to,
                    String uri)

Add Error Page mapping for a status code range. This method is not available from web.xml and must be called directly.

Parameters:
  `from` - The lowest matching status code
  `to` - The highest matching status code
  `uri` - The URI of the error page.

#### doStart

    protected void doStart()
                    throws Exception

Description copied from class: `AggregateLifeCycle`
Start the managed lifecycle beans in the order they were added.

Overrides:
  `doStart` in class `AbstractHandler`
Throws:
  `Exception`
See Also:
  `AbstractLifeCycle.doStart()`

#### doStop

    protected void doStop()
                   throws Exception

Description copied from class: `AggregateLifeCycle`
Stop the joined lifecycle beans in the reverse order they were added.

Overrides:
  `doStop` in class `AbstractHandler`
Throws:
  `Exception`
See Also:
  `AbstractLifeCycle.doStart()`